package Scalar;

use strict;
use Carp;

sub new {
	my $class = shift;
	my %args = @_;
	my $self = {};

	foreach (keys %args) {
		$self->{$_} = $args{$_};
		#print __PACKAGE__ . ": " . $_ . ": " . $args{$_} . "\n";
	}
	
	$self->{type} = $args{type} . $args{count}; # 'v' . '4' = v4
	$self->{len} = $args{len} * $args{count}; # 2 * 4 = 8
	delete $self->{count};

	# valid
	if ($args{type} && $args{len}) {
		$self->{pack} = sub : method {
			my ($self, $chash, $bin) = @_;
			
			$$bin .= pack($self->{type}, $chash);
		
			return 0;
		};
		$self->{unpack} = sub : method {
			my ($self, $chash, $bin, $position) = @_;
				
			$$chash = unpack($self->{type}, substr($$bin, $$position, $self->{len}));
			$$position += $self->{len};
			
			return 0;
		};
	} else {
			 croak __PACKAGE__ . ": We should not be here!\n";
	}
	
	return bless $self, $class;
}

sub DESTROY {
	my ($self) = @_;
}

sub pack : method {&{$_[0]->{pack}}(@_);}

sub unpack : method {&{$_[0]->{unpack}}(@_);}



1;