package Struct;

use strict;
use Carp;

sub new {
	my $class = shift;
	my %args = @_;
	my $self = {};

	foreach (keys %args) {
		$self->{$_} = $args{$_};
		#print __PACKAGE__ . ": " . $_ . ": " . $args{$_} . "\n";
	}

	# struct with nested struct|array inside
	if ($args{nested}) {
		# struct with multiple nests in a chain (on same level of nesting)
		if (ref($args{nested}) eq 'ARRAY') {
			# self unpack
			if ($args{keys} && $args{types} && $args{len}) {
				# name
				if($args{name}) {
					$self->{pack} = sub : method {
						my ($self, $chash, $bin) = @_;
		
						$$bin .= pack($self->{types}, @{$chash->{$self->{name}}}{@{$self->{keys}}});
	
						foreach(@{$self->{nested}}) {
							$_->pack(\%{$chash->{$self->{name}}}, $bin);
						}
		
						return 0;
					};
					$self->{unpack} = sub : method {
						my ($self, $chash, $bin, $position) = @_;
			
						@{$chash->{$self->{name}}}{@{$self->{keys}}} = unpack($self->{types}, substr($$bin, $$position, $self->{len}));
						$$position += $self->{len};
	
						foreach(@{$self->{nested}}) {
							$_->unpack(\%{$chash->{$self->{name}}}, $bin, $position);
						}
	
						return 0;
					};
				# no name
				} else {
					$self->{pack} = sub : method {
						my ($self, $chash, $bin) = @_;
		
						$$bin .= pack($self->{types}, @{$chash}{@{$self->{keys}}});
						
						foreach(@{$self->{nested}}) {
							$_->pack($chash, $bin);
						}
		
						return 0;
					};
					$self->{unpack} = sub : method {
						my ($self, $chash, $bin, $position) = @_;
		
						@{$chash}{@{$self->{keys}}} = unpack($self->{types}, substr($$bin, $$position, $self->{len}));
						$$position += $self->{len};
	
						foreach(@{$self->{nested}}) {
							$_->unpack($chash, $bin, $position);
						}
			
						return 0;
					};
				}
			# no self unpack
			} else {
				# name
				if($args{name}) {
					$self->{pack} = sub : method {
						my ($self, $chash, $bin) = @_;
			
							foreach(@{$self->{nested}}) {
								$_->pack(\%{$chash->{$self->{name}}}, $bin);
							}
			
						return 0;
					};
					$self->{unpack} = sub : method {
						my ($self, $chash, $bin, $position) = @_;
							
							foreach(@{$self->{nested}}) {
								$_->unpack(\%{$chash->{$self->{name}}}, $bin, $position);
							}
			
						return 0;
					};
				# no name
				} else {
					$self->{pack} = sub : method {
						my ($self, $chash, $bin) = @_;
			
							foreach(@{$self->{nested}}) {
								$_->pack($chash, $bin);
							}
			
						return 0;
					};
					$self->{unpack} = sub : method {
						my ($self, $chash, $bin, $position) = @_;
							
							foreach(@{$self->{nested}}) {
								$_->unpack($chash, $bin, $position);
							}
			
						return 0;
					};
				}
			}
		# struct with 1 nest
		} else {
			# self unpack
			if ($args{keys} && $args{types} && $args{len}) {
				# name
				if($args{name}) {
					$self->{pack} = sub : method {
						my ($self, $chash, $bin) = @_;
		
						$$bin .= pack($self->{types}, @{$chash->{name}}{@{$self->{keys}}});
	
						$self->{nested}->pack(\%{$chash->{$self->{name}}}, $bin);
		
						return 0;
					};
					$self->{unpack} = sub : method {
						my ($self, $chash, $bin, $position) = @_;
			
						@{$chash->{$self->{name}}}{@{$self->{keys}}} = unpack($self->{types}, substr($$bin, $$position, $self->{len}));
						$$position += $self->{len};
	
						$self->{nested}->unpack(\%{$chash->{$self->{name}}}, $bin, $position);
	
						return 0;
					};
				# no name
				} else {
					$self->{pack} = sub : method {
						my ($self, $chash, $bin) = @_;
		
						$$bin .= pack($self->{types}, @{$chash}{@{$self->{keys}}});
						
						$self->{nested}->pack($chash, $bin);
		
						return 0;
					};
					$self->{unpack} = sub : method {
						my ($self, $chash, $bin, $position) = @_;
		
						@{$chash}{@{$self->{keys}}} = unpack($self->{types}, substr($$bin, $$position, $self->{len}));
						$$position += $self->{len};
	
						$self->{nested}->unpack($chash, $bin, $position);
			
						return 0;
					};
				}
			# no self unpack
			} else {
				# name
				if($args{name}) {
					$self->{pack} = sub : method {
						my ($self, $chash, $bin) = @_;

						$self->{nested}->pack(\%{$chash->{$self->{name}}}, $bin);

						return 0;
					};
					$self->{unpack} = sub : method {
						my ($self, $chash, $bin, $position) = @_;

						$self->{nested}->unpack(\%{$chash->{$self->{name}}}, $bin, $position);

						return 0;
					};
				# no name
				} else {
					$self->{pack} = sub : method {
						my ($self, $chash, $bin) = @_;
			
						$self->{nested}->pack($chash, $bin);
			
						return 0;
					};
					$self->{unpack} = sub : method {
						my ($self, $chash, $bin, $position) = @_;
							
						$self->{nested}->unpack($chash, $bin, $position);
			
						return 0;
					};
				}
			}
		}
	# simple struct
	} else {
		# valid
		if ($args{keys} && $args{types}) {
			# count
			if($args{len}) {
				# name
				if($args{name}) {
					$self->{pack} = sub : method {
						my ($self, $chash, $bin) = @_;
			
						$$bin .= pack($self->{types}, @{$chash->{$self->{name}}}{@{$self->{keys}}});
		
						return 0;
					};
					$self->{unpack} = sub : method {
						my ($self, $chash, $bin, $position) = @_;
				
						@{$chash->{$self->{name}}}{@{$self->{keys}}} = unpack($self->{types}, substr($$bin, $$position, $self->{len}));
						$$position += $self->{len};
				
						return 0;
					};
					# no name
				} else {
					$self->{pack} = sub : method {
						my ($self, $chash, $bin) = @_;
			
						$$bin .= pack($self->{types}, @{$chash}{@{$self->{keys}}});
			
						return 0;
					};
					$self->{unpack} = sub : method {
						my ($self, $chash, $bin, $position) = @_;
			
						@{$chash}{@{$self->{keys}}} = unpack($self->{types}, substr($$bin, $$position, $self->{len}));
						$$position += $self->{len};
				
						return 0;
					};
				}
			# slurp (a*)
			} else {
				# name
				if($args{name}) {
					$self->{pack} = sub : method {
						my ($self, $chash, $bin) = @_;
			
						$$bin .= pack($self->{types}, @{$chash->{$self->{name}}}{@{$self->{keys}}});
			
						return 0;
					};
					$self->{unpack} = sub : method {
						my ($self, $chash, $bin, $position) = @_;
				
						@{$chash->{$self->{name}}}{@{$self->{keys}}} = unpack($self->{types}, substr($$bin, $$position));
						$$position += ($self->{types} =~ /(\d+)$/ ? $1 : length($$bin));
				
						return 0;
					};
				# no name
				} else {
					$self->{pack} = sub : method {
						my ($self, $chash, $bin) = @_;
			
						$$bin .= pack($self->{types}, @{$chash}{@{$self->{keys}}});
			
						return 0;
					};
					$self->{unpack} = sub : method {
						my ($self, $chash, $bin, $position) = @_;
			
						@{$chash}{@{$self->{keys}}} = unpack($self->{types}, substr($$bin, $$position));
						$$position += ($self->{types} =~ /(\d+)$/ ? $1 : length($$bin));
				
						return 0;
					};
				}
			}
		# invalid
		} else {
			 croak __PACKAGE__ . ": We should not be here!\n";
		}
	}
	
	return bless $self, $class;
}

sub DESTROY {
	my ($self) = @_;
}

sub pack : method {&{$_[0]->{pack}}(@_);}

sub unpack : method {&{$_[0]->{unpack}}(@_);}



1;